unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables, Grids, DBGrids, ExtCtrls, Menus,
  About,NovaFirm,VybVse,SQLfirma,SetrKde, TabNotBk, StdCtrls, Mask, DBCtrls,
  UpdateF,SQLTelef,NovyTele,VybVseT,UpdateT,Adresar, ComCtrls;

type
  TForm1 = class(TForm)
    Query1: TQuery;
    DataSource1: TDataSource;
    MainMenu1: TMainMenu;
    Soubor: TMenuItem;
    Konec1: TMenuItem;
    Firmy: TMenuItem;
    Napoveda: TMenuItem;
    Oaplikaci1: TMenuItem;
    Pomoc1: TMenuItem;
    N2: TMenuItem;
    Novafirma1: TMenuItem;
    Vybrat1: TMenuItem;
    Vse2: TMenuItem;
    SQLprikaz1: TMenuItem;
    N3: TMenuItem;
    Uprav1: TMenuItem;
    UpravAktualni1: TMenuItem;
    Vechny1: TMenuItem;
    Zaznamkde2: TMenuItem;
    Sloupce1: TMenuItem;
    ID2: TMenuItem;
    Nazev2: TMenuItem;
    Cena100Kg2: TMenuItem;
    Mesto2: TMenuItem;
    Ulice2: TMenuItem;
    PSC2: TMenuItem;
    Poznamka2: TMenuItem;
    N1: TMenuItem;
    N4: TMenuItem;
    TabbedNotebook1: TTabbedNotebook;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    ButtonKonec: TButton;
    SmazatF1: TMenuItem;
    SmazatVse2: TMenuItem;
    SmazatAktualni2: TMenuItem;
    Refresh1: TMenuItem;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Query2: TQuery;
    Telefony: TMenuItem;
    Novytelefon1: TMenuItem;
    SmazatT1: TMenuItem;
    SmazatAktualniT2: TMenuItem;
    SmazatVseT2: TMenuItem;
    N5: TMenuItem;
    VybratT1: TMenuItem;
    N6: TMenuItem;
    SQLprikazT1: TMenuItem;
    SetriditPodleT2: TMenuItem;
    Telefonykaktulnfirm1: TMenuItem;
    UpravT1: TMenuItem;
    Aktualn1: TMenuItem;
    SloupceT1: TMenuItem;
    FIRMY_ID2: TMenuItem;
    Telefon2: TMenuItem;
    Oddeleni2: TMenuItem;
    PoznamkaT2: TMenuItem;
    Kontrolakonzistence1: TMenuItem;
    Vsechnytelefony2: TMenuItem;
    N7: TMenuItem;
    Aktivovatdatabase1: TMenuItem;
    Adresuloendatabz1: TMenuItem;
    Vytvoritdatabase1: TMenuItem;
    Table1: TTable;
    N8: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Pomoc1Click(Sender: TObject);
    procedure Oaplikaci1Click(Sender: TObject);
    procedure Novafirma1Click(Sender: TObject);
    procedure Vse2Click(Sender: TObject);
    procedure SQLprikaz1Click(Sender: TObject);
    procedure ID2Click(Sender: TObject);
    procedure Nazev2Click(Sender: TObject);
    procedure Cena100Kg2Click(Sender: TObject);
    procedure Mesto2Click(Sender: TObject);
    procedure Ulice2Click(Sender: TObject);
    procedure PSC2Click(Sender: TObject);
    procedure Poznamka2Click(Sender: TObject);
    procedure Zaznamkde2Click(Sender: TObject);
    procedure ButtonKonecClick(Sender: TObject);
    procedure UpravAktualni1Click(Sender: TObject);
    procedure SmazatVse2Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure SmazatAktualni2Click(Sender: TObject);
    procedure Vechny1Click(Sender: TObject);
    procedure SQLprikazT1Click(Sender: TObject);
    procedure SmazatAktualniT2Click(Sender: TObject);
    procedure SmazatVseT2Click(Sender: TObject);
    procedure FIRMY_ID2Click(Sender: TObject);
    procedure Telefon2Click(Sender: TObject);
    procedure Oddeleni2Click(Sender: TObject);
    procedure PoznamkaT2Click(Sender: TObject);
    procedure Kontrolakonzistence1Click(Sender: TObject);
    procedure Novytelefon1Click(Sender: TObject);
    procedure Telefonykaktulnfirm1Click(Sender: TObject);
    procedure SetriditPodleT2Click(Sender: TObject);
    procedure Vsechnytelefony2Click(Sender: TObject);
    procedure Aktualn1Click(Sender: TObject);
    procedure Aktivovatdatabase1Click(Sender: TObject);
    procedure Adresuloendatabz1Click(Sender: TObject);
    procedure Vytvoritdatabase1Click(Sender: TObject);
  private
    { Private declarations }
     { firma }
    procedure ProvedSQL(SQL : string);
    procedure ProvedSQLSelect(SQL : string);
    function NazevJeUnique(nazev : string) : bool;
    function VyberSloupce : string;
    function IDjeZobrazen(DBGrid : TDbgrid) : integer;
    procedure VytvorFirmy;
     { telefony }
    procedure ProvedSQLT(SQL : string);
    procedure ProvedSQLSelectT(SQL : string);
    function TelefonJeUnique(telefon : string) : bool;
    function VyberSloupceT : string;
    function TelefonjeZobrazen(DBGrid : TDbgrid) : string;
    procedure VytvorTelefony;
  public
    { Public declarations }
  end;

const
  CRLF = #13#10;
  PROFI = 'Tato funkce je dostupn pouze ve verzi programu Cement Profi';
var
  Form1: TForm1;
  Aktualni_ID : integer; { zde se uklada ID vybrane firmy pro manipulaci s tabulkou TELEFONY}
implementation

{$R *.DFM}
{-- Uivatelsk funkce -------------------------------------------------}
function TForm1.VyberSloupce : string;
{Tato funkce vrati retezec obsahujici nazvy vsech sloupcu, ktere jsou
 vybrany (Checked = true) v menu Firmy->Sloupce oddelene carkou. Pouziva
 se pro sestaveni SQL prikazu SELECT}
var s : string;
    zacatek : bool;
begin

s := ' ';
zacatek := true; {Pred prvnim vybranym sloupcem nesmi byt carka.}

if ID2.Checked then
   begin
      zacatek := false;
      s := s + 'ID';
   end;

if Nazev2.Checked then
   if zacatek then
      begin
           zacatek:= false;
           s := s + 'Nazev';
      end
   else    s := s + ',Nazev';

if Cena100Kg2.Checked then
   if zacatek then
      begin
           zacatek:= false;
           s := s + 'Cena_100Kg';
      end
   else    s := s + ',Cena_100Kg';

if Mesto2.Checked then
      if zacatek then
      begin
           zacatek:= false;
           s := s + 'Mesto';
      end
   else    s := s + ',Mesto';

if Ulice2.Checked then
      if zacatek then
      begin
           zacatek:= false;
           s := s + 'Ulice';
      end
   else    s := s + ',Ulice';

if PSC2.Checked then
      if zacatek then
      begin
           zacatek:= false;
           s := s + 'PSC';
      end
   else    s := s + ',PSC';

if Poznamka2.Checked then
      if zacatek then
      begin
           {zacatek:= false;}
           s := s + 'Poznamka';
      end
   else    s := s + ',Poznamka';

if Length(s) <= 1 then s := ' *';

VyberSloupce := s + ' ';
end;


procedure TForm1.ProvedSQL(SQL : string);
{Ulozi stavajici prikaz SELECT, provede jiny prikaz SQL nez je SELECT
a puvodni SELECT zase obnovi, jinak by DBGrid1 po jinem prikazu nez je
SELECT nezobrazoval zadna data. Pro prikaz SELECT se pouziva procedura
ProvedSQLSelect}
var s : string;
    select : string;
    i : integer;
begin
ShowMessage(SQL);
select := '';
for i := 0 to Query1.SQL.Count-1 do  { ulozeni puvodniho prikazu select }
    select := select + Query1.SQL.Strings[i];
Query1.Active := false;
Query1.SQL.Clear;
Query1.SQL.Add(SQL);
try
    Query1.ExecSQL;
    ProvedSQLSelect(select);{obnovenni puvodniho prikazu select }
{   Query1.Active := true; Provede procedure ProvedSQLSelect }
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ShowMessage(s);
    ProvedSQLSelect(select);{obnovenni puvodniho prikazu select }
    end;
  end;
end;

procedure TForm1.ProvedSQLSelect(SQL : string);
var s : string;
begin
ShowMessage(SQL);
Query1.Active := false;
Query1.SQL.Clear;
Query1.SQL.Add(SQL);
try
    Query1.ExecSQL;
    Query1.Active := true;
    TabbedNotebook1.PageIndex := 0; { Po provedeni prikazu SELECT
    se vysledek zobrazi v DBGrid1 umistene v TabbedNotebook1 na nultem liste}
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ShowMessage(s);
    end;
  end;
end;

function TForm1.NazevJeUnique(nazev : string) : bool;
{Zjistuje, zda je nazev firmy je unique (vraci true) nebo je v databazi
jiz obsazen (vraci false)}
var s : string;
    select : string;
    i : integer;
    navrat : bool;
begin
navrat := false;
select := '';
for i := 0 to Query1.SQL.Count-1 do  { ulozeni puvodniho prikazu select }
    select := select + Query1.SQL.Strings[i];

Query1.Active := false;

s := 'SELECT * FROM firmy WHERE nazev ="';
s := s + nazev;
s := s + '";';

Query1.SQL.Clear;
Query1.SQL.Add(s);
try
    Query1.ExecSQL;
    Query1.Active := true;
    if (Query1.RecordCount <> 0) then {byl nalezen zaznam s hledanym nazvem}
    begin
       navrat := false;
       ShowMessage('Zaznam s timto nazvem ji existuje');
    end
    else
        navrat := true;
    ProvedSQLSelect(select);{obnovenni puvodniho prikazu select }
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ShowMessage(s);
    ProvedSQLSelect(select);{obnovenni puvodniho prikazu select }
    end;
  end;
NazevJeUnique := navrat;
end;

function TForm1.IDjeZobrazen(DBGrid : TDbgrid) : integer;
{Zjistuje, zda je ID v DBGrid zobrazeno a pokud ano, tak vraci hodnotu
 ID aktualniho zaznamu}
var i : integer;
    navrat : integer;
begin
navrat := -1;

for i := 0 to DBGrid.FieldCount -1 do {Hleda se sloupec s nazvem ID}
    begin
          if DBGrid.Fields[i].DisplayLabel = 'ID' then
            navrat := StrToInt(DBGrid.Fields[i].AsSTring);
    end;

IDjeZobrazen := navrat;
end;
{------------------------------------------------------------------------}

procedure TForm1.FormCreate(Sender: TObject);
begin
Top := (Screen.Height div 2) - (Height div 2);
Left := (Screen.Width div 2) - (Width div 2);
Aktualni_ID := -1; { Neni vybrana zadna firma pro manipulaci s Tel.Cisly}
end;

{ -------------------- menu soubor ------------------- }
procedure TForm1.Aktivovatdatabase1Click(Sender: TObject);
{Aktivuji se databaze v adresary vybranem pomoci polozky menu
Soubor -> Adresar ulozeni dtabasi.
Po aktivaci databazi se obe polozky menu vypnou}
begin
  try
     Query1.Active := true;
     Query2.Active := true;
     Aktivovatdatabase1.Enabled := false;
     Adresuloendatabz1.Enabled := false;
  except
     ShowMessage('Databze se nepodailo inicializovat.'
     + CRLF + 'Je cesta k souborm databze korektn?');
  end;
end;

procedure TForm1.Adresuloendatabz1Click(Sender: TObject);
{Umoznuje nastavit v Query1 a Query2 cestu k databazim pred jejich
aktivaci pomoci polozky menu Soubor->Aktivovat database}
begin
     FormAdresar.EditAdresar.Text := Query1.DatabaseName;
if   (FormAdresar.ShowModal = mrOK) AND
     (FormAdresar.EditAdresar.Text <> '')
  then
     begin
     try
          Query1.DatabaseName := FormAdresar.EditAdresar.Text;
          Query2.DatabaseName := FormAdresar.EditAdresar.Text;
     except
            ShowMessage('Databze v zadanm adresi nebyli nalezeny.'
            + CRLF + 'Zadali-jste na konci cesty sptn lomtko?');
     end;
     end;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
{Obnovi data databaze ze souboru pomoci metory Refresh. Pote je potreba
znovu spusit SQL prikaz, aby se zmeny dat projevili v DBGrid}
begin
     try
         Query1.Refresh; Query1.Active := false;
         Query1.ExecSQL; Query1.Active := true;
         Query2.Refresh; Query2.Active := false;
         Query2.ExecSQL; Query1.Active := true;
     except
            ShowMessage('Dolo k chyb pi obnovovn databze' + CRLF
            + 'Jsou databze aktivovny?');
     end;

end;

procedure TForm1.Kontrolakonzistence1Click(Sender: TObject);
{Diky moznosti zadavani SQL prikazu je mozne narusit konzistenci
dtabaze napr. tak, ze je smazana firma, ale telefony k ni v databazi
zustanou.}
begin
ShowMessage(PROFI);
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
Close;
end;
{ -------------------- konec menu soubor ------------ }

procedure TForm1.Pomoc1Click(Sender: TObject);
begin
MessageDlg(PROFI + CRLF + 'Registrovanou verzi produktu si mete objednat' +
' na telefonnm sle 555-555555',mtInformation, [mbOk],0);
end;

procedure TForm1.Oaplikaci1Click(Sender: TObject);
begin
AboutBox.ShowModal;
end;

procedure TForm1.Novafirma1Click(Sender: TObject);
var s : string;
i : integer;
begin

s := 'INSERT INTO firmy(Nazev,Cena_100Kg,Mesto,Ulice,PSC,Poznamka)';
s := s + 'VALUES ("';
if (FormNovaFirma.ShowModal = mrOK) AND
   (Length(FormNovaFirma.MaskNazev.Text) <> 0) AND {Jmeno firmy musi byt zadano}
   NazevJeUnique(FormNovaFirma.MaskNazev.Text) then {Jmeno firmy musi byt unikatni}
   begin
   s := s + FormNovaFirma.MaskNazev.Text + '",';
   s := s + FormNovaFirma.MaskCena.Text + ',"';
   s := s + FormNovaFirma.MaskMesto.Text + '","';
   s := s + FormNovaFirma.MaskUlice.Text + '","';
   s := s + FormNovaFirma.MaskPSC.Text + '","';
   for i := 0 to FormNovaFirma.Memo1.Lines.Count-1 do {Poznamka z komponenty Memo}
         s := s + FormNovaFirma.Memo1.Lines.Strings[i];
   s := s + '");';
   ProvedSQL(s);
   end
else
    ShowMessage('Zznam neuloen');
end;

procedure TForm1.Vse2Click(Sender: TObject);
{Vybere sloupce, ktere jsou vybrany v menu Firmy->Sloupce a setridi je
podle vybraneho kriteria}
var s: string;
begin
{nelze tridit podle sloupcu, ktere nejsou zobrazeny}
FormVybratVse.RadioNazev.Enabled := Nazev2.Checked;
FormVybratVse.RadioID.Enabled := ID2.Checked;
FormVybratVse.RadioMesto.Enabled := Mesto2.Checked;
FormVybratVse.RadioCena.Enabled := Cena100kg2.Checked;
FormVybratVse.RadioNE.Checked := true;
{-------------------------------------------------}

if (FormVybratVse.ShowModal = mrOK) then
begin
s := 'SELECT ' + VyberSloupce + ' FROM firmy ';

if FormVybratVse.RadioNazev.Checked = true then
   s := s + 'ORDER BY Nazev'
else if FormVybratVse.RadioID.Checked = true then
   s := s + 'ORDER BY ID'
else if FormVybratVse.RadioMesto.Checked = true then
   s := s + 'ORDER BY Mesto'
else if FormVybratVse.RadioCena.Checked = true then
   s := s + 'ORDER BY Cena_100Kg';

if (FormVybratVse.CheckDESC.Checked = true) AND
   (FormVybratVse.RadioNE.Checked = false) then
   s := s + ' DESC'; {Setridit sestupne}

s := s + ';';
ProvedSQLSelect(s);
end;
end;

procedure TForm1.SQLprikaz1Click(Sender: TObject);
{Provede SQL prikaz zadany v Memo1 na formulari FormSQLfrima.
Pokud uzivatel zatrhne moznost, ze prikaz bude SELECT, pouzije se
metoda provedSQLSelect, jinak provedSQL. Vice viz. provedSQL}
var
   i : integer;
   s : string;
begin
if (FormSQLfirma.ShowModal = mrOK) then
begin
s := '';
for i := 0 to FormSQLfirma.Memo1.Lines.Count -1 do
    s := s + FormSQLfirma.Memo1.Lines.Strings[i];

if (FormSQLfirma.Checkbox1.Checked = true) then
provedSQLSelect(s)
else
provedSQL(s);
end;
end;


procedure TForm1.ID2Click(Sender: TObject);
begin
ID2.Checked := not ID2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Nazev2Click(Sender: TObject);
begin
Nazev2.Checked := not Nazev2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Cena100Kg2Click(Sender: TObject);
begin
Cena100Kg2.Checked := not Cena100Kg2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Mesto2Click(Sender: TObject);
begin
Mesto2.Checked := not Mesto2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Ulice2Click(Sender: TObject);
begin
Ulice2.Checked := not Ulice2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.PSC2Click(Sender: TObject);
begin
PSC2.Checked := not PSC2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Poznamka2Click(Sender: TObject);
begin
Poznamka2.Checked := not Poznamka2.Checked;
provedSQLSelect('SELECT' + VyberSloupce + ' FROM FIRMY;');
end;

procedure TForm1.Zaznamkde2Click(Sender: TObject);
{Zobrazi formular pro vyber podminek, pro prikaz SELECT (FormSetrKde ...}
var s : string;
    zacatek : bool; {pred prvni podminkou nesmi byt carka. Je-li podminka
    prvni urcuje promenna zacatek}
begin
s := '';
zacatek := true;
if (FormSetrKde.ShowModal = mrOK) then
   begin
   s := 'SELECT ' + VyberSloupce + 'FROM FIRMY ';

   { Sestaveni vyberovych kriterii}
   if FormSetrKde.CheckBoxNazev.Checked then begin
       zacatek := false;
       s := s + 'WHERE Nazev = "' + FormSetrKde.EditNazev.Text + '" ';
       end;

   if FormSetrKde.CheckBoxMesto.Checked then begin
       if zacatek then begin
           zacatek := false;
           s := s + 'WHERE ';
           end
       else s := s + 'AND ';
       s := s + 'Mesto = "' + FormSetrKde.EditMesto.Text + '" ';
   end;

   if FormSetrKde.CheckBoxUlice.Checked then begin
       if zacatek then begin
           zacatek := false;
           s := s + 'WHERE ';
           end
       else s := s + 'AND ';
       s := s + 'Ulice = "' + FormSetrKde.EditUlice.Text + '" ';
   end;

   if FormSetrKde.CheckBoxPSC.Checked then begin
       if zacatek then begin
           zacatek := false;
           s := s + 'WHERE ';
           end
       else s := s + 'AND ';
       s := s + 'PSC = "' + FormSetrKde.MaskEditPSC.Text + '" ';
   end;


   if FormSetrKde.CheckBoxCena1.Checked then begin
       if zacatek then begin
           zacatek := false;
           s := s + 'WHERE ';
           end
       else s := s + 'AND ';
       s := s + 'Cena_100Kg ' + FormSetrKde.ComboBoxCena1.Text
       + ' ' + FormSetrKde.MaskEditCena1.Text + ' ';
   end;

   if FormSetrKde.CheckBoxCena2.Checked then begin
       if zacatek then begin
           {zacatek := false;}
           s := s + 'WHERE ';
           end
       else s := s + 'AND ';
       s := s + 'Cena_100Kg ' + FormSetrKde.ComboBoxCena2.Text
       + ' ' + FormSetrKde.MaskEditCena2.Text + ' ';
   end;

   s := s + ';';
   ProvedSQLSelect(s);
   end;
end;

procedure TForm1.ButtonKonecClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.UpravAktualni1Click(Sender: TObject);
var ID : integer;
     s,PuvodniNazev : string; { PuvodniNazev je nutny pro podminku
     UPDATE ... WHERE Nazev = PuvodniNazev}
     i,j,k : integer;
begin
ID := IDjeZobrazen(DBGrid1); {Vrati ID (primarni klic) firmy, neni li zobrazena,
pak -1}
if ID < 0 then
ShowMessage('Pokud chcete pracovat s aktulnm zznamem,'
            + CRLF + 'muste mt zobrazen soupec ID')
else
    begin
         {ShowMessage('ID je ' + IntToStr(ID));}

         {Ve formuli budou zobrazeny jen ty hodnoty sloupcu, kter
         jsou vybrny v aktulnm zznamu}
         for i := 0 to DBGrid1.FieldCount -1 do {prochazi se sloupec za sloupcem}
             begin
                if (DBGrid1.Fields[i].DisplayLabel = 'Nazev') then
                      begin
                        FormUpdateFirma.MaskNazev.Text := DBGrid1.Fields[i].AsString;
                        PuvodniNazev := FormUpdateFirma.MaskNazev.Text;
                      end;
                if (DBGrid1.Fields[i].DisplayLabel = 'Cena_100Kg') then
                    begin
                        s := DBGrid1.Fields[i].AsString;
                        { nektere zemne oddeluji cenu teckou a ne carkou. Nasledujici
                        kod najde a zamneni carku za tecku.}
                        j := Length(s); {desetinna carka je na konci}
                        for k := 0 to Length(s) do
                          begin
                            if s[k] = '.' then begin
                               j := k;
                               break;
                            end;
                            if s[k] = ',' then begin
                               j := k;
                               s[k] := '.';
                               break;
                            end;
                          end;
                       {Pro spravne prirazeni do komponenty MaksEdit (MaskCena) je
                       treba, aby retezec obsahoval presny pocet cislic, aby byla
                       spravne prirazena desetinna carka.}
                       case Length(s)-j of
                        0:
                          case Length(s) of
                               1: s := '000' + s + '.0';
                               2: s := '00' + s + '.0';
                               3: s := '0' + s + '.0';
                          end;
                        1:
                          case Length(s) of
                               3: s := '000' + s;
                               4: s := '00' + s;
                               5: s := '0' + s;
                          end;
                        2:
                          case Length(s) of
                               4: s := '000' + s;
                               5: s := '00' + s;
                               6: s := '0' + s;
                          end;
                        end;
                        FormUpdateFirma.MaskCena.Text := s;
                    end;
                if (DBGrid1.Fields[i].DisplayLabel = 'Mesto') then
                        FormUpdateFirma.MaskMesto.Text := DBGrid1.Fields[i].AsString;
                if (DBGrid1.Fields[i].DisplayLabel = 'Ulice') then
                        FormUpdateFirma.MaskUlice.Text := DBGrid1.Fields[i].AsString;
                if (DBGrid1.Fields[i].DisplayLabel = 'PSC') then
                        FormUpdateFirma.MaskPSC.Text := DBGrid1.Fields[i].AsString;
                if (DBGrid1.Fields[i].DisplayLabel = 'Poznamka') then begin
                        FormUpdateFirma.Memo1.Lines.Clear;
                        FormUpdateFirma.Memo1.Lines.Add(DBGrid1.Fields[i].AsString);
                    end;
             end;
         {Nyni je formular vyplnen hodnotamy z aktualniho zaznamu a po jeho zobrazeni
         a zmnene nekterych hodnot uzivatelem se hodnoty z formulare ulozi do databaze}

         s := 'UPDATE firmy SET ';
         if (FormUpdateFirma.ShowModal = mrOK) AND
            (Length(FormUpdateFirma.MaskNazev.Text) <> 0) AND
                        ((PuvodniNazev = FormUpdateFirma.MaskNazev.Text) OR
                        {nazev se nezmenil, nebo se zmenil a pak musi byt unikatni}
                        NazevJeUnique(FormUpdateFirma.MaskNazev.Text))
           then
             begin
                s := s + 'NAZEV = "' + FormUpdateFirma.MaskNazev.Text + '",';
                s := s + 'CENA_100Kg = ' + FormUpdateFirma.MaskCena.Text + ',';
                s := s + 'Mesto = "' + FormUpdateFirma.MaskMesto.Text + '",';
                s := s + 'Ulice = "' + FormUpdateFirma.MaskUlice.Text + '",';
                s := s + 'PSC = "'   + FormUpdateFirma.MaskPSC.Text + '",';
                s := s + 'Poznamka = "';
                for i := 0 to FormUpdateFirma.Memo1.Lines.Count-1 do
                         s := s + FormUpdateFirma.Memo1.Lines.Strings[i] + ' ';
                s := s + '" WHERE ID = ' + IntToStr(ID) + ';';
                ProvedSQL(s);
             end
else
    ShowMessage('Zznam nebyl aktualizovn');
    end;
end;

procedure TForm1.SmazatVse2Click(Sender: TObject);
begin
if MessageDlg('Opravdu chcete smazat vechny firmy???' + CRLF
   + 'Budou smazny i vechny telefonn sla!',mtWarning,[mbAll,mbNO],0)
   = mrAll then begin
     ProvedSQL('DELETE FROM firmy');
     ProvedSQLT('DELETE FROM telefony');
     end
     else
     ShowMessage('Dobr Volba :-)');
end;

procedure TForm1.SmazatAktualni2Click(Sender: TObject);
var ID : integer;
begin
if MessageDlg('Opravdu chcete smazat aktuln firmu?' + CRLF
   + 'Budou smazny i vechny odpovdajc telefonn sla!',
   mtWarning,[mbOK,mbCancel],0) = mrOK then
   begin
        ID := IDjeZobrazen(DBGrid1); {Vrati ID aktualniho zaznamu nebo -1 pokud
        ID neni v DBGrid1 zobrazeno}
        if ID >= 0 then begin
           ProvedSQL('DELETE FROM FIRMY WHERE ID = ' + IntToStr(ID) + ';');
           ProvedSQLT('DELETE FROM TELEFONY WHERE FIRMY_ID = ' + IntToStr(ID) + ';');
           end
        else
            ShowMessage('Pokud chcete pracovat s aktulnm zznamem,'
            + CRLF + 'muste mt zobrazen soupec ID');
   end
else
   ShowMessage('Dobr Volba :-)');

end;

procedure TForm1.Vechny1Click(Sender: TObject);
{Procedura pro upravu vsech zaznamu najednou}
begin
MessageDlg(PROFI,mtInformation, [mbOk],0);
end;


{============================================================================}
{---------------------------- Prace s telefony ------------------------------}
{============================================================================}
{-- Uivatelsk funkce -------------------------------------------------}

function TForm1.VyberSloupceT : string;
{Obdoba metody VyberSloupce (pro firmy) pro telefony}
var s : string;
    zacatek : bool;
begin

s := ' ';
zacatek := true;

if FIRMY_ID2.Checked then
   begin
      zacatek := false;
      s := s + 'FIRMY_ID';
   end;

if Telefon2.Checked then
   if zacatek then
      begin
           zacatek:= false;
           s := s + 'Telefon';
      end
   else    s := s + ',Telefon';

if Oddeleni2.Checked then
   if zacatek then
      begin
           zacatek:= false;
           s := s + 'Oddeleni';
      end
   else    s := s + ',Oddeleni';

if PoznamkaT2.Checked then
      if zacatek then
      begin
          {zacatek:= false;}
           s := s + 'Poznamka';
      end
   else    s := s + ',Poznamka';

if Length(s) <= 1 then s := ' *';

VyberSloupceT := s + ' ';
end;

procedure TForm1.ProvedSQLT(SQL : string);
{Obdoba funkce ProvedSQL (pro firmy) pro telefony}
var s : string;
    select : string;
    i : integer;
begin
ShowMessage(SQL);
select := '';
for i := 0 to Query2.SQL.Count-1 do  { ulozeni puvodniho prikazu select }
    select := select + Query2.SQL.Strings[i];
Query2.Active := false;
Query2.SQL.Clear;
Query2.SQL.Add(SQL);
try
    Query2.ExecSQL;
    ProvedSQLSelectT(select);{obnovenni puvodniho prikazu select }
{   Query1.Active := true; Provede procedure ProvedSQLSelect }
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ShowMessage(s);
    ProvedSQLSelectT(select);{obnovenni puvodniho prikazu select }
    end;
  end;
end;


procedure TForm1.ProvedSQLSelectT(SQL : string);
{Obdoba funkce ProvedSQLSelect (pro firmy) pro telefony}
var s : string;
begin
ShowMessage(SQL);
Query2.Active := false;
Query2.SQL.Clear;
Query2.SQL.Add(SQL);
try
    Query2.ExecSQL;
    Query2.Active := true;
    TabbedNotebook1.PageIndex := 1;
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ShowMessage(s);
    end;
  end;
end;

function TForm1.TelefonJeUnique(telefon : string) : bool;
{Obdoba funkce NazevJeUnique (pro firmy) pro telefony}
var s : string;
    select : string;
    i : integer;
    navrat : bool;
begin
navrat := false;
select := '';
for i := 0 to Query2.SQL.Count-1 do  { ulozeni puvodniho prikazu select }
    select := select + Query2.SQL.Strings[i];

Query2.Active := false;

s := 'SELECT ' + VyberSloupceT +' FROM telefony WHERE telefon ="';
s := s + telefon;
s := s + '";';

Query2.SQL.Clear;
Query2.SQL.Add(s);
try
    Query2.ExecSQL;
    Query2.Active := true;
    if (Query2.RecordCount <> 0) then
    begin
       navrat := false;
       ShowMessage('Zaznam s timto telefonem ji existuje');
    end
    else
        navrat := true;
    ProvedSQLSelectT(select);{obnovenni puvodniho prikazu select }
except on E:EDBEngineError do begin
    s := 'Dolo k chyb, kter znemonila proveden pkazu.';
    s := s + CRLF + 'Pvodn hlen: ' + E.Message+CRLF;
    s := s + 'Ostrate pinu chyby a mete pikaz provst znovu.';
    ProvedSQLSelectT(select);{obnovenni puvodniho prikazu select }
    end;
  end;
TelefonJeUnique := navrat;
end;

function TForm1.TelefonjeZobrazen(DBGrid : TDbgrid) : string;
{Obdoba funkce IDjeZobrazen}
var i : integer;
    navrat : string;
begin
navrat := '';

for i := 0 to DBGrid.FieldCount -1 do
    begin
         if DBGrid.Fields[i].DisplayLabel = 'Telefon' then
            navrat := DBGrid.Fields[i].AsSTring;
    end;

TelefonjeZobrazen := navrat;
end;
{------------------------------------------------------------------------}

procedure TForm1.SQLprikazT1Click(Sender: TObject);
{Obdoba funkce SQLprikaz (pro firmy) pro telefony}
var
   i : integer;
   s : string;
begin
if (FormSQLtelefony.ShowModal = mrOK) then
begin
s := '';
for i := 0 to FormSQLtelefony.Memo1.Lines.Count -1 do
    s := s + FormSQLtelefony.Memo1.Lines.Strings[i];

if (FormSQLtelefony.Checkbox1.Checked = true) then
provedSQLSelectT(s)
else
provedSQLT(s);
end;
end;

procedure TForm1.SmazatAktualniT2Click(Sender: TObject);
var Telefon : string;
begin
if MessageDlg('Opravdu chcete smazat aktuln telefon?',
   mtWarning,[mbOK,mbCancel],0) = mrOK then
   begin
        Telefon := TelefonjeZobrazen(DBGrid2);
        if Telefon <> '' then
           ProvedSQLT('DELETE FROM Telefony WHERE TELEFON = "' + Telefon + '";')
        else
            ShowMessage('Pokud chcete pracovat s aktulnm zznamem,'
            + CRLF + 'muste mt zobrazen soupec Telefon');
   end
else
   ShowMessage('Dobr Volba :-)');
end;

procedure TForm1.SmazatVseT2Click(Sender: TObject);
begin
if MessageDlg('Opravdu chcete smazat vechny telefony??',
   mtWarning,[mbAll,mbNO],0) = mrAll then begin
     ProvedSQLT('DELETE FROM telefony');
     end
     else
     ShowMessage('Dobr Volba :-)');
end;


procedure TForm1.FIRMY_ID2Click(Sender: TObject);
begin
FIRMY_ID2.Checked := not FIRMY_ID2.Checked;
provedSQLSelectT('SELECT' + VyberSloupceT + ' FROM TELEFONY;');
end;

procedure TForm1.Telefon2Click(Sender: TObject);
begin
Telefon2.Checked := not Telefon2.Checked;
provedSQLSelectT('SELECT' + VyberSloupceT + ' FROM TELEFONY;');
end;

procedure TForm1.Oddeleni2Click(Sender: TObject);
begin
Oddeleni2.Checked := not Oddeleni2.Checked;
provedSQLSelectT('SELECT' + VyberSloupceT + ' FROM TELEFONY;');
end;

procedure TForm1.PoznamkaT2Click(Sender: TObject);
begin
PoznamkaT2.Checked := not PoznamkaT2.Checked;
provedSQLSelectT('SELECT' + VyberSloupceT + ' FROM TELEFONY;');
end;

procedure TForm1.Novytelefon1Click(Sender: TObject);
var s : string;
i,ID : integer;
begin
{ -- aktualni firma -- }
ID := IDjeZobrazen(DBGrid1);
if ID < 0 then begin
   ShowMessage('Pokud chcete vloit telefon k aktulnmu zznamemu,'
   + CRLF + 'muste mt zobrazen soupec ID v tabulce FIRMY');
   end
{---- firm byla nalezena -----}
 else
   begin
     FormNovyTelefon.LabelFirma.Caption := IntToStr(ID) + ' ';
     for i := 0 to DBGrid1.FieldCount -1 do
         if (DBGrid1.Fields[i].DisplayLabel = 'Nazev') then
            FormNovyTelefon.LabelFirma.Caption := FormNovyTelefon.LabelFirma.Caption +
            DBGrid1.Fields[i].AsString;

     if (FormNovyTelefon.ShowModal = mrOK) AND
        (Length(FormNovyTelefon.MaskTelefon.Text) <> 0) AND
           TelefonJeUnique(FormNovyTelefon.MaskTelefon.Text) then
              begin
                 s := 'INSERT INTO telefony (FIRMY_ID,Telefon,Oddeleni,Poznamka) VALUES (';
                 s := s + IntToStr(ID) + ',"';
                 s := s + FormNovyTelefon.MaskTelefon.Text + '","';
                 s := s + FormNovyTelefon.MaskOddeleni.Text + '","';
                 for i := 0 to FormNovyTelefon.Memo1.Lines.Count-1 do
                          s := s + FormNovyTelefon.Memo1.Lines.Strings[i];
                 s := s + '");';
                 ProvedSQLT(s);
              end
     else
         ShowMessage('Zznam neuloen');
   end;
end;

procedure TForm1.Telefonykaktulnfirm1Click(Sender: TObject);
begin
{ -- aktualni firma -- }
Aktualni_ID := IDjeZobrazen(DBGrid1);
if Aktualni_ID < 0 then
   ShowMessage('Pokud chcete vloit telefon k aktulnmu zznamemu,'
   + CRLF + 'muste mt zobrazen soupec ID v tabulce FIRMY')
 else
     begin
     ProvedSQLSelectT('SELECT ' + VyberSloupceT + 'FROM telefony WHERE firmy_id = '
     + IntToStr(Aktualni_ID) + ';');
     end;
end;

procedure TForm1.SetriditPodleT2Click(Sender: TObject);
var s : string;
begin
{nelze tridit podle sloupcu, ktere nejsou zobrazeny}
FormVybratVseT.RadioFirmy_ID.Enabled := Firmy_ID2.Checked;
FormVybratVseT.RadioTelefon.Enabled := Telefon2.Checked;
FormVybratVseT.RadioOddeleni.Enabled := Oddeleni2.Checked;
FormVybratVseT.RadioNE.Checked := true;
{-------------------------------------------------}

if (FormVybratVseT.ShowModal = mrOK) then
begin
s := 'SELECT ' + VyberSloupceT + ' FROM telefony ';

if Aktualni_ID >= 0 then
    s := s + ' WHERE FIRMY_ID = ' + IntToStr(Aktualni_ID) + ' ';

if FormVybratVseT.RadioFirmy_ID.Checked = true then
   s := s + 'ORDER BY firmy_id'
else if FormVybratVseT.RadioTelefon.Checked = true then
   s := s + 'ORDER BY Telefon'
else if FormVybratVseT.RadioOddeleni.Checked = true then
   s := s + 'ORDER BY Oddeleni';

if (FormVybratVseT.CheckDESC.Checked = true) AND
   (FormVybratVseT.RadioNE.Checked = false) then
   s := s + ' DESC';

s := s + ';';
ProvedSQLSelectT(s);
end;
end;

procedure TForm1.Vsechnytelefony2Click(Sender: TObject);
begin
Aktualni_ID := -1; {Nebudou vybrany telefony pro jednu firmu, ale pro vsechny}
provedSQLSelectT('SELECT' + VyberSloupceT + ' FROM TELEFONY;');
end;

procedure TForm1.Aktualn1Click(Sender: TObject);
{ Procedura pro upravu aktualniho telefonniho cisla}
var
     s,telefon,PuvodniTelefon : string;
     i : integer;
begin
telefon := telefonJeZobrazen(DBGrid2); {Telefon zde funguje jako primarni klic}
if telefon = '' then
ShowMessage('Pokud chcete pracovat s aktulnm zznamem,'
            + CRLF + 'muste mt zobrazen soupec telefon')
else
    begin
    {    ShowMessage('Telefon is ' + telefon);}
         {Ve formuli budou zobrazeny jen ty hodnoty sloupcu, kter
         jsou vybrny v aktulnm zznamu}
         for i := 0 to DBGrid2.FieldCount -1 do
             begin
                if (DBGrid2.Fields[i].DisplayLabel = 'Telefon') then
                    begin
                        FormUpdateTelefon.MaskTelefon.Text := DBGrid2.Fields[i].AsString;
                        PuvodniTelefon := FormUpdateTelefon.MaskTelefon.Text;
                    end;
                if (DBGrid2.Fields[i].DisplayLabel = 'FIRMY_ID') then
                        FormUpdateTelefon.LabelFirma.Caption := DBGrid2.Fields[i].AsString;
                if (DBGrid2.Fields[i].DisplayLabel = 'Oddeleni') then
                        FormUpdateTelefon.MaskOddeleni.Text := DBGrid2.Fields[i].AsString;
                if (DBGrid2.Fields[i].DisplayLabel = 'Poznamka') then begin
                        FormUpdateTelefon.Memo1.Lines.Clear;
                        FormUpdateTelefon.Memo1.Lines.Add(DBGrid2.Fields[i].AsString);
                   end;
             end;

         s := 'UPDATE telefony SET ';
         if (FormUpdateTelefon.ShowModal = mrOK) AND
            (Length(FormUpdateTelefon.MaskTelefon.Text) <> 0) AND
                        ((PuvodniTelefon = FormUpdateTelefon.MaskTelefon.Text) OR
                        TelefonJeUnique(FormUpdateFirma.MaskNazev.Text))
           then
             begin
                s := s + 'Telefon = "' + FormUpdateTelefon.MaskTelefon.Text + '",';
                s := s + 'Oddeleni = "' + FormUpdateTelefon.MaskOddeleni.Text + '",';
                s := s + 'Poznamka = "';
                for i := 0 to FormUpdateTelefon.Memo1.Lines.Count-1 do
                         s := s + FormUpdateTelefon.Memo1.Lines.Strings[i] + ' ';
                s := s + '" WHERE Telefon = "' + PuvodniTelefon + '";';
                ProvedSQLT(s);
             end
else
    ShowMessage('Zznam nebyl aktualizovn');
    end;
end;

{ ----------------- vytvoreni database  firmy -----------------------}
procedure TForm1.VytvorFirmy;
begin
  with Table1 do
  begin
    Active := False;  { The Table component must not be active }

    { First, describe the type of table and give it a name }
    DatabaseName := Query1.DatabaseName;
    TableType := ttdBase;
    TableName := 'firmy.dbf';

    { Next, describe the fields in the table }
    with FieldDefs do
    begin
      Clear;
      Add('ID', ftAutoInc,0,False); 
      Add('Nazev', ftString, 30, False);
      Add('Cena_100Kg', ftFloat, 0, False);
      Add('Mesto',ftString, 20,False);
      Add('Ulice',ftString,20,False);
      Add('PSC',ftString,6,False);
      Add('Poznamka',ftString,100,False);
    end;

    { Next, describe any indexes }
    with IndexDefs do
    begin
      Clear;
      { The first index has no name because it is a Paradox primary key }
      Add('', 'ID', [ixPrimary, ixUnique]);
      Add('Fld2Indx', 'nazev', [ixUnique]);
    end;
    { Now that we have specified what we want, create the table }
    CreateTable;
    ShowMessage('Tabulka firmy vytvorena');
  end;
end;

{ -------------------------------------------------------------------}
{ ----------------- vytvoreni database  telefony --------------------}
procedure TForm1.VytvorTelefony;
begin
  with Table1 do
  begin
    Active := False;  { The Table component must not be active }

    { First, describe the type of table and give it a name }
    DatabaseName := Query1.DatabaseName;
    TableType := ttdBase;
    TableName := 'telefony.dbf';

    { Next, describe the fields in the table }
    with FieldDefs do
    begin
      Clear;
      Add('Telefon', ftString, 12, False);
      Add('Oddeleni',ftString, 30, False);
      Add('FIRMY_ID', ftInteger,0,False);
      Add('Poznamka',ftString,100,False);
    end;

    { Next, describe any indexes }
    with IndexDefs do
    begin
      Clear;
    Add('TelIndx', 'telefon', [ixUnique]);
    end;
    { Now that we have specified what we want, create the table }
    CreateTable;
    ShowMessage('Tabulka telefony vytvorena');
  end;
end;

{ -------------------------------------------------------------------}


procedure TForm1.Vytvoritdatabase1Click(Sender: TObject);
begin
VytvorFirmy;
VytvorTelefony;
end;

end.
